/**************************************************************************
 *                                                                        *
 * This code has been developed by Andrea Graziani. Those intending to    *
 * use this software module in hardware or software products are advised  *
 * that its use may infringe existing patents or copyrights, and any such * 
 * use would be at such party's own risk. The original developer of this  *
 * software module and his/her company, and subsequent editors and their  *
 * companies (including Project Mayo), will have no liability for use of  *
 * this software or modifications or derivatives thereof.                 *
 *                                                                        *
 * Project Mayo gives users of the Codec and Filter a license to this     *
 * software  module or modifications thereof for use in hardware or       *
 * software products claiming conformance to the MPEG-4 Video Standard    *
 * as described in the Open DivX license.                                 *
 *                                                                        *
 * The complete Open DivX license can be found at                         *
 * http://www.projectmayo.com/opendivx/license.php                        *
 *                                                                        *
 **************************************************************************/
/**
*  Copyright (C) 2001 - Project Mayo
 *
 * Andrea Graziani
 *
 * DivX Advanced Research Center <darc@projectmayo.com>
*
**/
// divxfilterinterface.h //

#ifndef _DIVXFILTERINTERFACE_
#define _DIVXFILTERINTERFACE_

#ifdef __cplusplus
extern "C" {
#endif

	// {D132EE97-3E38-4030-8B17-59163B30A1F5}
	DEFINE_GUID(IID_IDivXFilterInterface, 
	0xd132ee97, 0x3e38, 0x4030, 0x8b, 0x17, 0x59, 0x16, 0x3b, 0x30, 0xa1, 0xf5);
	
  DECLARE_INTERFACE_(IDivXFilterInterface, IUnknown)
  {
		STDMETHOD (get_PPLevel) (
			THIS_ int * PPLevel // current postprocessing level
      ) PURE;
		
		STDMETHOD (put_PPLevel) (
			THIS_ int PPLevel // new postprocessing level
      ) PURE;
		
		STDMETHOD(put_DefaultPPLevel) (THIS) PURE;
  };

#ifdef __cplusplus
}
#endif
#endif // _DIVXFILTERINTERFACE_
