/**************************************************************************
 *                                                                        *
 * This code has been developed by Andrea Graziani. Those intending to    *
 * use this software module in hardware or software products are advised  *
 * that its use may infringe existing patents or copyrights, and any such * 
 * use would be at such party's own risk. The original developer of this  *
 * software module and his/her company, and subsequent editors and their  *
 * companies (including Project Mayo), will have no liability for use of  *
 * this software or modifications or derivatives thereof.                 *
 *                                                                        *
 * Project Mayo gives users of the Codec and Filter a license to this     *
 * software  module or modifications thereof for use in hardware or       *
 * software products claiming conformance to the MPEG-4 Video Standard    *
 * as described in the Open DivX license.                                 *
 *                                                                        *
 * The complete Open DivX license can be found at                         *
 * http://www.projectmayo.com/opendivx/license.php                        *
 *                                                                        *
 **************************************************************************/
/**
*  Copyright (C) 2001 - Project Mayo
 *
 * Andrea Graziani
 *
 * DivX Advanced Research Center <darc@projectmayo.com>
*
**/
// divxfilterproperties.h //

#include "divxfilterinterface.h"

const int MinPPLevel = 0;
const int MaxPPLevel = 100;

class DivXFilterProperties :
	public CBasePropertyPage
{
public:
	static CUnknown * WINAPI CreateInstance(LPUNKNOWN lpunk, HRESULT * phr);

private:
	DivXFilterProperties(LPUNKNOWN lpunk, HRESULT * phr);
	~DivXFilterProperties();
	HRESULT OnConnect(IUnknown *pUnknown);
	HRESULT OnDisconnect();
	HRESULT OnDeactivate();
	HRESULT OnApplyChanges();
  BOOL OnReceiveMessage(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam);

  void OnSliderNotification(WPARAM wParam);
  HWND CreateSlider(HWND hwndParent);
  HWND m_hwndSlider;

  void SetDirty();

  int m_ciPPOnExit; // remember contrast level for CANCEL
  int m_ciPPLevel;  // and likewise for next activate

  IDivXFilterInterface * m_pDivXFilterInterface;

  IDivXFilterInterface * pIDivXFilter() {
      ASSERT(m_pDivXFilterInterface);
      return m_pDivXFilterInterface;
  };
};
